#ifndef _FKP_MOTIONDATA_H_HEADER_
#define _FKP_MOTIONDATA_H_HEADER_

#include <FK/FK.h>

enum fk_MotionInterType {
	LINEAR,
	SPHERE,
	POWER,
	REV_POWER,
	FREEZE,
	HIDE	// <----------------------------------------------------IuWFNĝւΉ̂ߒǉ
};

class CKeyFrameMotion {
	friend class CMotionCharactor;

private:
	vector<fk_Quaternion>		qArray;
	vector<int>					frameArray;
	vector<fk_MotionInterType>	interTypeArray;

	vector<fk_Vector>			basePosArray;
	vector<fk_Vector>			scaleArray;

	fk_Vector		getInterVec(const fk_Vector &, const fk_Vector &, double, fk_MotionInterType = LINEAR);
	fk_Quaternion	getInterQ(const fk_Quaternion &, const fk_Quaternion &, double, fk_MotionInterType = LINEAR);

public:
	CKeyFrameMotion();
	~CKeyFrameMotion();

	void init(void);

	void pushKeyFrame(const fk_Quaternion &, const fk_Vector &, int, fk_MotionInterType, int = -1);			// L[ǉ(q)
	void pushKeyFrame(const fk_Quaternion &, const fk_Vector &, const fk_Vector &, int, fk_MotionInterType, int = -1);	// L[ǉ(e)
	bool changeKeyFrame(int, const fk_Quaternion &, const fk_Vector &, int, fk_MotionInterType);				// L[C(q)
	bool changeKeyFrame(int, const fk_Quaternion &, const fk_Vector &, const fk_Vector &, int, fk_MotionInterType);	// L[C(e)
	bool deleteKeyFrame(int);

	bool isBaseMotion(void);					// basePosArray ɒlX^bNĂ true Ԃ

	int getTotalKeyNum(void);					// ̊֐߂L[t[Ԃ(z̃TCY)
	int getTotalFrameNum(int = -1);				// ̊֐߂[Ṽg[^t[ԂAlwŎw肵L[̃Xg܂ł̃t[
	bool getFrameToKeyID(int, int *, int *);	// ^ꂽt[ẘ֐߂̃L[t[ ID Ƃ̒ŉt[ڂԂ

	int setFrameState(int, fk_Model *);	// ^ꂽt[ɕԃ[V𐶐AԒl͂̊֐߂̕\ON/OFF

};

#endif
